#!/usr/bin/env python
# -*- coding: utf-8 -*- 


#Time-stamp: <2011-10-29 10:45:55 Saturday by roowe>
#File Name: thuner_xl_with_wget.py
#Author: bestluoliwe@gmail.com
#My Blog: www.iroowe.com

import re
import time
import os
import logging
import sys
from htmlentitydefs import entitydefs
import subprocess
import re
import hashlib
import urllib, urllib2
import Cookie
import cookielib

LOG_FILE = os.path.expanduser("~/thuner_with_wget.log")
log = None
def log_init(log_file, quiet=False):
    logger = logging.getLogger()
    logger.setLevel(logging.DEBUG)
    hdlr = logging.FileHandler(log_file)
    formatter = logging.Formatter("%(asctime)s %(levelname)s %(message)s")
    hdlr.setFormatter(formatter)
    logger.addHandler(hdlr)
    if not quiet:
        hdlr = logging.StreamHandler()
        hdlr.setFormatter(formatter)
        logger.addHandler(hdlr)
    return logger

def md5pwd(passwd, verifycode):
    hash = passwd
    for i in xrange(0, 2):
        m = hashlib.md5()    
        m.update(hash)
        hash = m.hexdigest()

    m = hashlib.md5()
    m.update(hash + verifycode)
    return m.hexdigest()

def format_cookie_file(filename):
    f = open(filename, 'r')
    lines = f.readlines()
    f.close()

    f = open(filename, 'w')
    for line in lines:
        line = line.replace('\t\t', '\t0\t')
        f.write(line)

    f.close()

def get_cookie(filename, username, passwd):
    verifycode = ''
    userid = ''
    gdrive_id = ''
    cookies = []

    ckjar = cookielib.MozillaCookieJar(filename)
    ckproc = urllib2.HTTPCookieProcessor(ckjar)
    opener = urllib2.build_opener(ckproc)

    req = urllib2.Request('http://login.xunlei.com/check?u=%s&cachetime=%d' % (username, time.time() * 1000))
    req.add_header('User-Agent', 'Mozilla/5.0 (Windows NT 5.1; rv:7.0.1) Gecko/20100101 Firefox/7.0.1')
    req.add_header('Referer', 'http://lixian.vip.xunlei.com/task.html')

    resp = opener.open(req)
    for cookie in ckjar:
        if cookie.name == 'check_result':
            verifycode = cookie.value[2:]
                
    #login
    values = {'u':username, 'p':md5pwd(passwd, verifycode), 'verifycode':verifycode, 'login_enable':'0', 'login_hour':'720'}
    req = urllib2.Request('http://login.xunlei.com/sec2login', urllib.urlencode(values))
    req.add_header('User-Agent', 'Mozilla/5.0 (Windows NT 5.1; rv:7.0.1) Gecko/20100101 Firefox/7.0.1')
    req.add_header('Referer', 'http://lixian.vip.xunlei.com/task.html')

    resp = opener.open(req)
    for cookie in ckjar:
        if cookie.name == 'userid':
            userid = cookie.value

    values = {'cachetime':time.time() * 1000, 'cachetime':time.time() * 1000, 'from':'1'}
    req = urllib2.Request('http://dynamic.cloud.vip.xunlei.com/login', urllib.urlencode(values))
    req.add_header('User-Agent', 'Mozilla/5.0 (Windows NT 5.1; rv:7.0.1) Gecko/20100101 Firefox/7.0.1')

    resp = opener.open(req)
    htm = resp.read()
    gdrive_id = re.compile(r'<input type="hidden" id="cok" value="(\S+)" .*/>').findall(htm)[0]
    resp.close()

    ckjar.save(ignore_discard=True, ignore_expires=False)
    f = open(filename, 'a')
    f.write('.vip.xunlei.com\tTRUE\t/\tFALSE\t\tgdriveid\t%s\n' % (gdrive_id))
    f.close()
    format_cookie_file(filename)

def handle_entitydef(matchobj):
    key = matchobj.group(1)
    if entitydefs.has_key(key):
        return entitydefs[key]
    else:
        return matchobj.group(0)
def collect_urls(html, only_bturls = False):
    """
    collect urls
    """
    urls = []
    for name, url in re.findall(r"<a.+?name=['\"]bturls['\"] title=['\"](.+?)['\"].+?href=['\"](http.+?)['\"]>", html):
        name = re.sub("&(.*?);", handle_entitydef, name)
        url = re.sub("&(.*?);", handle_entitydef, url)
        urls.append((name, url))
    if not only_bturls:
        for id, name in re.findall(r'<input id=[\'"]durl(\w+?)[\'"].+title=[\'"](.+?)[\'"].+', html):
            result = re.search(r'<input id=[\'"]dl_url%s[\'"].+value=[\'"](http.*?)[\'"]' % id, html)
            if result:
                name = re.sub("&(.*?);", handle_entitydef, name)
                url = result.group(1)
                url = re.sub("&(.*?);", handle_entitydef, url)
                urls.append((name, url))
    log.info("Filter get %d links" % len(urls))
    return urls
def choose_download(urls):
    download_list = []
    for i in xrange(0, len(urls)):
        print '[%02d] %s' % (i + 1, urls[i][0])

    input = raw_input("Download [1,2,3; Default All]: ").strip()
    idx = input.split(',')
    for i in idx:
        try:
            i = int(i)
        except:
            continue
        
        if i > 0 and i < len(urls) + 1:
            download_list.append(urls[i - 1])

    if len(download_list) == 0:
        return urls
    else:
        return download_list
def thuner_xl_with_wget(urls, output_dir, cookies_file, quiet=False, limit_rate=None):
    download_list = choose_download(urls)
    for name, url in download_list:
        if len(url) == 0:
            log.debug("Empty Link, Name: " + name)
            continue
        cmd = ["wget", "--load-cookies", cookies_file, "-c", "-t", "5", "-O", os.path.join(output_dir, name), url]
        if quiet:
            cmd.insert(1, "-q")
        if limit_rate > 0:
            cmd.insert(1, "--limit-rate=%s" % (limit_rate))
        log.info("wget cmd: '%s'" % ' '.join(cmd))
        ret = subprocess.call(cmd)
        if ret != 0:
            log.debug("wget returned %d." % ret)
            if ret in (3, 8):
                log.error("Give up '%s', may be already finished download, or something wrong with disk." % name)
            else:
                urls.append((name, url))
                log.error("will retry for %s later." % name)
            continue
        else:
            log.info("Finished %s" % name)
        time.sleep(2)
def thuner_xl_with_aria2c(urls, output_dir, cookies_file, quiet=False):
    """
    download with aria2c
    """
    download_list = choose_download(urls)
    for name, url in download_list:
        if len(url) == 0:
            log.debug("Empty Link, Name: " + name)
            continue
        cmd = ["aria2c", "--load-cookies", cookies_file, "-d", output_dir, "-c", "-m", "5", "-s", "5", "--use-head=false", "-o", name, url]
        if quiet:
            cmd.insert(1, "-q")
        log.info("aria2 cmd: '%s'" % ' '.join(cmd))
        ret = subprocess.call(cmd)
        if ret != 0:
            log.debug("aria2 returned %d." % ret)
            if ret in (13):
                log.error("Give up '%s', file already existed." % name)
            else:
                urls.append((name, url))
                log.error("the exit status number is %d, and then will retry for %s later." % (ret, name))
            continue
        else:
            log.info("Finished %s" % name)
        time.sleep(2)

def user_task_page(cookies_file, page_file):
    """
    尝试自动下载我的下载任务表
    """

    userid = ''

    ckjar = cookielib.MozillaCookieJar()
    try:
        ckjar.load(cookies_file, ignore_expires=True, ignore_discard=True)
    except:
        log.info('load cookie error')
        return

    for cookie in ckjar:
        if cookie.name == 'userid':
            userid = cookie.value

    page_url = "http://dynamic.cloud.vip.xunlei.com/user_task?userid=%s&st=0" % (userid)
    cmd = ["wget", "--load-cookies", cookies_file, "-t", "5", "-U", "Mozilla", "-O", page_file, page_url]
    ret = subprocess.call(cmd)
    if ret != 0:
        log.info("Can't get user task page")

if __name__ == "__main__":
    import optparse
    parser = optparse.OptionParser(description='Thuner li xian with wget')
    parser.add_option('-p',  dest='p', default="~/user_task.htm", help="load page file")
    parser.add_option('-c',  dest='c', default="~/cookies.txt", help="load cookie file")
    parser.add_option('-o',  dest='o', default="~/Downloads", help="output dir")
    parser.add_option('-r', dest='r', help="limit rate")
    parser.add_option('-b', dest='b', action='store_true', default=False, help="bt files only")
    parser.add_option('-q', dest='q', action="store_true", default=False, help="quiet, only log to file.")
    parser.add_option('-a', dest='a', action="store_true", default=False, help="download with aria2c")
    parser.add_option('-u', dest='u', help="xunlei user name")
    parser.add_option('-w', dest='w', help="xunlei password")
    (options,args) = parser.parse_args()

    only_bturls, cookies_file, output_dir, page_file, quiet, limit_rate = options.b, options.c, options.o, options.p, options.q, options.r
    username, passwd = options.u, options.w

    page_file = os.path.expanduser(page_file)
    cookies_file = os.path.realpath(os.path.expanduser(cookies_file))
    output_dir = os.path.expanduser(output_dir)

    log = log_init(LOG_FILE, quiet = quiet)
    if username == '' or passwd == '':
        log.info("your name and password for xunlei account are needed.")
        sys.exit(0)

    get_cookie(cookies_file, username, passwd)
    user_task_page(cookies_file, page_file)
    if not os.path.exists(cookies_file):
        log.info("please export cookies file")
        sys.exit(0)
    if not os.path.isdir(output_dir):
        log.info("No such %s", output_dir)
        sys.exit(0)
    with open(page_file) as f:
        page_html = f.read()
    urls = collect_urls(page_html, only_bturls)
    if not options.a:
        thuner_xl_with_wget(urls, output_dir, cookies_file, quiet, limit_rate)
    else:
        thuner_xl_with_aria2c(urls, output_dir, cookies_file, quiet)
